%define spu_version 3.3
%define spu_release 73
%define gcc_version 4.1.1
%define _unpackaged_files_terminate_build 1
%define newlib_version 1.14.0
Summary: SPU compiler and toolchain
Name: spu-toolchain
Version: %{spu_version}
Release: %{spu_release}
License: GPL
Group: Development/Languages
Source0: toolchain-%{spu_version}-src.tar.bz2
Source1: gdb-6.5.tar.bz2
Source2: newlib-%{newlib_version}.tar.gz
Source3: newlib-patches-%{newlib_version}.tar.gz
# 1: already integrated
Patch1: toolchain-binutils-overflow.diff
# 2: not applicable
Patch2: toolchain-libstdcxx-configury.diff
# 3: integrated 2006-11-23
Patch3: toolchain-rfc00053.diff
Patch4: toolchain-crt0-formalize.diff
Patch5: toolchain-user-alignment.diff
# 6: not applicable: divsf3 not present in mainline spu.md
Patch6: toolchain-spu-divsf3.diff
Patch7: toolchain-fixed-range.diff
# 8: not applicable
Patch8: toolchain-noskipdirs.diff
Patch9: toolchain-wordmodefix.diff
Patch10: diff-spu-gdb
# 11: not applicable
Patch11: toolchain-build-revert.diff 
Patch12: toolchain-dwarf-fbreg-fix.diff
Patch13: diff-combined-tree
Patch15: diff-spu-gdb-overlay-gdbarch
Patch16: diff-spu-gdb-overlay-tdep
Patch17: diff-spu-gdb-overlay-test
Patch18: diff-gcc-spu-realign-load
# 19: already integrated
Patch19: toolchain-libstdcxx-section-flags.diff
# 20: not applicable
Patch20: toolchain-testsuite-mechanical.diff
# 21: not applicable
Patch21: embedspu-use-one-file.diff
# 22: not applicable
Patch22: embedspu-handle_ear.diff
Patch23: toolchain-gcc-cleanup.diff
# 24: already integrated
Patch24: toolchain-pr28862-fix.diff
Patch25: toolchain-intrinsic-mapping.diff
Patch26: diff-spu-gdb-lowpczero
Patch27: diff-gcc-reduc-patterns-and-multitypes
Patch28: diff-gcc-spu-widenmult
Patch29: toolchain-no-timode.diff
# 30: already integrated
Patch30: diff-spu-binutils
# 31: already integrated
Patch31: diff-spu-binutils-fixes
# 32: already integrated
Patch32: diff-spu-binutils-fixes2
# 33: already integrated
Patch33: diff-spu-binutils-fixes3
# 34: already integrated
Patch34: diff-spu-binutils-fixes4
# 35: already integrated
Patch35: diff-spu-binutils-fixes5
# 36: already integrated
Patch36: diff-spu-binutils-fixes6
# 37: integrated 2006-11-23
Patch37: toolchain-rfc00062.diff
# 38: already integrated
Patch38: diff-spu-binutils-fixes7
# 39: integrated 2006-11-23
Patch39: toolchain-libspec-pg.diff
# 40: already integrated
Patch40: diff-spu-binutils-fixes8
Patch41: toolchain-test-fixes-set1.diff
# 42: already integrated
Patch42: diff-spu-binutils-fixes9
# 43: already integrated
Patch43: diff-spu-binutils-fixes10
Patch44: toolchain-test-gcc-defs.diff
Patch45: diff-gcc-min-vect-loop-bound
# 46: already integrated
Patch46: toolchain-rfc00065.diff
# 47: already integrated
Patch47: diff-spu-binutils-fixes11
Patch48: toolchain-test-fixes-set2.diff
Patch49: diff-combined-dep
# 50: already integrated
Patch50: diff-spu-binutils-fixes12
Patch51: diff-longdouble-fix
Patch52: toolchain-categorize-keyword.diff
# 53: already integrated
Patch53: ppu-binutils-merge.diff
# 54: already integrated
Patch54: binutils-config.diff
# 55: already integrated
Patch55: binutils-power5.diff
# 56: already integrated
Patch56: binutils-spu-note.diff
# 57: already integrated
Patch57: toolchain-torture-strlen.diff
Patch58: diff-gcc-spu-vect-tests-fixes
# 59: already integrated
Patch59: binutils-spu-local-store.diff
# 60: not applicable
Patch60: toolchain-vector-init.diff
# 61: not applicable
Patch61: toolchain-vector-init-headers.diff
# 62: already integrated
Patch62: binutils-plt.diff
Patch63: diff-spu-gdb-ext
Patch64: diff-gdb-qxfer
Patch65: diff-gdb-qxfer-spu
Patch66: diff-sms-enable
Patch67: toolchain-rfc00067.diff
Patch68: toolchain-common-sysroot.diff
# 69: already integrated
Patch69: binutils-ppu-insn.diff
Patch70: diff-empty-latch-block
# 71: already integrated
Patch71: binutils-gasopt.diff
Patch72: toolchain-warnmain.diff
Patch73: toolchain-rfc00076.diff
Patch74: toolchain-stack-restore.diff
# 75: not applicable
Patch75: embedspu-shared-prefix.diff
# 76: already integrated
Patch76: binutils-spu-notevma.diff
# 77: already integrated
Patch77: binutils-gas-al.diff
# 78: already integrated
Patch78: binutils-loadaddr.diff
# 79: already integrated
Patch79: binutils-28945.diff
# 80: already integrated
Patch80: binutils-nm-segfault.diff

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: zlib-devel, dejagnu, bison, flex, texinfo, quilt

# Don't strip as the host binutils may be unable to handle SPU objects.
%define __os_install_post /usr/lib/rpm/brp-compress

# When building the cross-toolchain, reset prefix directory and use sysroot
%ifnarch ppc ppc64
%define _prefix /opt/cell/toolchain-%{version}
%define _mandir %{_prefix}/man
%define _infodir %{_prefix}/info
%define with_sysroot 1
%else
%define with_sysroot 0
%endif

%description
The spu-toolchain package contains a development tool chain for the
Cell Broadband Engine SPU architecture, consisting of the GNU Compiler
Collection version 4.1.1, GNU binutils version 2.16.1, and GNU newlib
version %{newlib_version}.

%package -n spu-gcc
Summary: SPU cross-compiler
Group: Development/Languages
Requires: spu-binutils = %{version}-%{release}
AutoProv: no
AutoReq: no

%description -n spu-gcc
GNU Compiler Collection C compiler for Cell Broadband Engine SPU.

%package -n spu-gcc-c++
Summary: C++ support for SPU cross-compiler
Group: Development/Languages
Requires: spu-gcc = %{version}-%{release}
AutoProv: no
AutoReq: no

%description -n spu-gcc-c++
GNU Compiler Collection C++ compiler for Cell Broadband Engine SPU.

%package -n spu-binutils
Summary: SPU cross-binutils
Group: Development/Tools
AutoProv: no
AutoReq: no
Provides: spu-utils
Obsoletes: spu-utils

%description -n spu-binutils
GNU binary utilities for Cell Broadband Engine SPU.

%package -n spu-newlib
Summary: SPU runtime library
Group: Development/Tools
AutoProv: no
AutoReq: no

%description -n spu-newlib
GNU newlib (%{newlib_version}) runtime library for Cell Broadband Engine SPU.

%package -n spu-gdb
Summary: SPU debugger
Group: Development/Tools
AutoProv: yes
AutoReq: yes

%description -n spu-gdb
GNU debugger for Cell Broadband Engine SPU (standalone).

%prep
%setup -c -q -a 1 -a 2 -a 3
%patch1 -p0
%patch2 -p0
%patch3 -p0
%patch4 -p0
%patch5 -p0
%patch6 -p0
%patch7 -p0
%patch8 -p0
%patch9 -p0
%patch10 -p0
%patch11 -p0
%patch12 -p0
%patch13 -p0
%patch15 -p0
%patch16 -p0
%patch17 -p0
%patch18 -p0
%patch19 -p0
%patch20 -p0
%patch21 -p0
%patch22 -p0
%patch23 -p0
%patch24 -p0
%patch25 -p0
%patch26 -p0
%patch27 -p0 -E
%patch28 -p0
%patch29 -p0
%patch30 -p0
%patch31 -p0
%patch32 -p0
%patch33 -p0
%patch34 -p0
%patch35 -p0
%patch36 -p0
%patch37 -p0
%patch38 -p0
%patch39 -p0
%patch40 -p0
%patch41 -p0
%patch42 -p0
%patch43 -p0
%patch44 -p0
%patch45 -p0
%patch46 -p0
%patch47 -p0
%patch48 -p0
%patch49 -p0
%patch50 -p0
%patch51 -p0
%patch52 -p0
%patch53 -p0
%patch54 -p0
%patch55 -p0
%patch56 -p0
%patch57 -p0
%patch58 -p0
%patch59 -p0
%patch60 -p0
%patch61 -p0
%patch62 -p0
%patch63 -p0
%patch64 -p0
%patch65 -p0
%patch66 -p0
%patch67 -p0
%patch68 -p0
%patch69 -p0
%patch70 -p0
%patch71 -p0
%patch72 -p0
%patch73 -p0
%patch74 -p0
%patch75 -p0
%patch76 -p0
%patch77 -p0
%patch78 -p0
%patch79 -p0
%patch80 -p0

pushd newlib-%{newlib_version}
ln -sf ../newlib-patches-%{newlib_version} patches
quilt push -a
popd

pushd toolchain/gcc
./contrib/gcc_update --touch
popd

# GDB directories don't work with symlinks for some reason
mv gdb-6.5/{gdb,readline} toolchain/binutils
# Fix some out-dated headers
cp -a toolchain/gcc/include/{ansidecl,floatformat}.h toolchain/binutils/include/

# Set up combined tree
rm -fr src
mkdir src
for I in newlib-%{newlib_version}/* toolchain/binutils/* toolchain/gcc/*; do
  ln -sf ../$I src
done

%build

%define spu_target_platform spu
%define spu_prefix spu-

rm -fr obj-%{spu_target_platform}
mkdir obj-%{spu_target_platform}
cd obj-%{spu_target_platform}

OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g' -e 's/-fno-exceptions//g'`
SPU_OPT_FLAGS="-O2 -g -pipe -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64"
CC="gcc $OPT_FLAGS -DBPA"
CC="$CC" CFLAGS="$SPU_OPT_FLAGS" CXXFLAGS="$SPU_OPT_FLAGS" XCFLAGS="$OPT_FLAGS" TCFLAGS="$SPU_OPT_FLAGS" \
	../src/configure --prefix=%{_prefix} --mandir=%{_mandir} --infodir=%{_infodir} \
%if %{with_sysroot}
	--with-sysroot=%{_prefix}/sysroot \
%endif
	--disable-shared --disable-threads --disable-checking --with-headers \
	--with-system-zlib --with-newlib \
	--enable-languages=c,c++ --disable-multilib --disable-nls \
	--enable-version-specific-runtime-libs --disable-libssp \
	--program-prefix=%{spu_prefix} \
	--target=%{spu_target_platform}

make %{?_smp_mflags}

%install
rm -fr $RPM_BUILD_ROOT

cd obj-%{spu_target_platform}
TARGET_PLATFORM=%{spu_target_platform}

make DESTDIR=$RPM_BUILD_ROOT install

FULLPATH=$RPM_BUILD_ROOT%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}

# fix some things
ln -sf %{spu_prefix}gcc $RPM_BUILD_ROOT%{_prefix}/bin/%{spu_prefix}cc
#rm -f $RPM_BUILD_ROOT%{_infodir}/dir
#gzip -9 $RPM_BUILD_ROOT%{_infodir}/*.info*
rm -f $RPM_BUILD_ROOT%{_prefix}/bin/%{spu_prefix}gcc-%{gcc_version}
rm -f $RPM_BUILD_ROOT%{_prefix}/bin/%{spu_prefix}gccbug
rm -f $RPM_BUILD_ROOT%{_prefix}/lib/libiberty.a
rm -f $RPM_BUILD_ROOT%{_prefix}/lib/libmmalloc.a
rm -f $RPM_BUILD_ROOT%{_prefix}/%{spu_target_platform}/lib/libiberty.a

rm -rf $RPM_BUILD_ROOT%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/install-tools
rm -rf $RPM_BUILD_ROOT%{_prefix}/libexec/gcc/%{spu_target_platform}/%{gcc_version}/install-tools

rm -f $RPM_BUILD_ROOT%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/*.la

for h in `find $FULLPATH/include -name \*.h`; do
  if grep -q 'It has been auto-edited by fixincludes from' $h; then
    rh=`grep -A2 'It has been auto-edited by fixincludes from' $h | tail -1 | sed 's|^.*"\(.*\)".*$|\1|'`
    diff -up $rh $h || :
    rm -f $h
  fi
done

cat > $RPM_BUILD_ROOT%{_prefix}/bin/%{spu_prefix}c89 <<"EOF"
#!/bin/sh
fl="-std=c89"
for opt; do
  case "$opt" in
    -ansi|-std=c89|-std=iso9899:1990) fl="";;
    -std=*) echo "`basename $0` called with non ANSI/ISO C option $opt" >&2
	    exit 1;;
  esac
done
exec %{_prefix}/bin/%{spu_prefix}gcc $fl ${1+"$@"}
EOF
cat > $RPM_BUILD_ROOT%{_prefix}/bin/%{spu_prefix}c99 <<"EOF"
#!/bin/sh
fl="-std=c99"
for opt; do
  case "$opt" in
    -std=c99|-std=iso9899:1999) fl="";;
    -std=*) echo "`basename $0` called with non ISO C99 option $opt" >&2
	    exit 1;;
  esac
done
exec %{_prefix}/bin/%{spu_prefix}gcc $fl ${1+"$@"}
EOF
chmod 755 $RPM_BUILD_ROOT%{_prefix}/bin/%{spu_prefix}c?9

# Remove Windows/Novell only man pages
rm -f $RPM_BUILD_ROOT%{_mandir}/man1/%{spu_prefix}{dlltool,nlmconv,windres}*

# Info and man7 files conflict with host toolchain files, 
# just remove them for now.
rm -rf $RPM_BUILD_ROOT%{_infodir}
rm -rf $RPM_BUILD_ROOT%{_mandir}/man7

cd ..

# Install the embedspu script
cp toolchain/scripts/embedspu.sh $RPM_BUILD_ROOT%{_prefix}/bin
chmod 755 $RPM_BUILD_ROOT%{_prefix}/bin/embedspu.sh
ln -sf embedspu.sh $RPM_BUILD_ROOT%{_prefix}/bin/embedspu

%clean
rm -rf $RPM_BUILD_ROOT

%files -n spu-gcc
%defattr(-,root,root)
%dir %{_prefix}
%dir %{_prefix}/bin
%dir %{_mandir}
%dir %{_mandir}/man1
%{_prefix}/bin/%{spu_prefix}cc
%{_prefix}/bin/%{spu_prefix}c89
%{_prefix}/bin/%{spu_prefix}c99
%{_prefix}/bin/%{spu_prefix}gcc
%{_prefix}/bin/%{spu_prefix}gcov
%{_prefix}/bin/%{spu_prefix}cpp
%{_mandir}/man1/%{spu_prefix}gcc.1*
%{_mandir}/man1/%{spu_prefix}gcov.1*
%{_mandir}/man1/%{spu_prefix}cpp.1*
%dir %{_prefix}/libexec
%dir %{_prefix}/libexec/gcc
%dir %{_prefix}/libexec/gcc/%{spu_target_platform}
%dir %{_prefix}/libexec/gcc/%{spu_target_platform}/%{gcc_version}
%{_prefix}/libexec/gcc/%{spu_target_platform}/%{gcc_version}/cc1
%{_prefix}/libexec/gcc/%{spu_target_platform}/%{gcc_version}/collect2
%dir %{_prefix}/lib
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{spu_target_platform}
%dir %{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include/stddef.h
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include/stdarg.h
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include/varargs.h
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include/float.h
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include/limits.h
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include/stdbool.h
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include/iso646.h
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include/unwind.h
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include/spu_*.h
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include/vmx2spu.h
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include/vec_types.h
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include/README
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/crt*.o
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/libgcc.a
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/libgcov.a

%files -n spu-gcc-c++
%defattr(-,root,root)
%dir %{_prefix}
%dir %{_prefix}/bin
%dir %{_mandir}
%dir %{_mandir}/man1
%{_prefix}/bin/%{spu_prefix}g++
%{_prefix}/bin/%{spu_prefix}c++
%{_mandir}/man1/%{spu_prefix}g++.1*
%dir %{_prefix}/lib
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{spu_target_platform}
%dir %{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include
%dir %{_prefix}/libexec
%dir %{_prefix}/libexec/gcc
%dir %{_prefix}/libexec/gcc/%{spu_target_platform}
%dir %{_prefix}/libexec/gcc/%{spu_target_platform}/%{gcc_version}
%{_prefix}/libexec/gcc/%{spu_target_platform}/%{gcc_version}/cc1plus
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/libstdc++.a
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/libsupc++.a
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include/c++

%files -n spu-binutils
%defattr(-,root,root)
%dir %{_prefix}
%dir %{_prefix}/bin
%dir %{_mandir}
%dir %{_mandir}/man1
%{_prefix}/bin/embedspu.sh
%{_prefix}/bin/embedspu
%{_prefix}/bin/%{spu_prefix}addr2line
%{_prefix}/bin/%{spu_prefix}ar
%{_prefix}/bin/%{spu_prefix}as
%{_prefix}/bin/%{spu_prefix}c++filt
%{_prefix}/bin/%{spu_prefix}ld
%{_prefix}/bin/%{spu_prefix}nm
%{_prefix}/bin/%{spu_prefix}objcopy
%{_prefix}/bin/%{spu_prefix}objdump
%{_prefix}/bin/%{spu_prefix}ranlib
%{_prefix}/bin/%{spu_prefix}readelf
%{_prefix}/bin/%{spu_prefix}size
%{_prefix}/bin/%{spu_prefix}strings
%{_prefix}/bin/%{spu_prefix}strip
%dir %{_prefix}/%{spu_target_platform}
%dir %{_prefix}/%{spu_target_platform}/bin
%dir %{_prefix}/%{spu_target_platform}/lib
%{_prefix}/%{spu_target_platform}/bin/*
%{_prefix}/%{spu_target_platform}/lib/ldscripts
%{_mandir}/man1/%{spu_prefix}addr2line.1*
%{_mandir}/man1/%{spu_prefix}ar.1*
%{_mandir}/man1/%{spu_prefix}as.1*
%{_mandir}/man1/%{spu_prefix}c++filt.1*
%{_mandir}/man1/%{spu_prefix}ld.1*
%{_mandir}/man1/%{spu_prefix}nm.1*
%{_mandir}/man1/%{spu_prefix}objcopy.1*
%{_mandir}/man1/%{spu_prefix}objdump.1*
%{_mandir}/man1/%{spu_prefix}ranlib.1*
%{_mandir}/man1/%{spu_prefix}readelf.1*
%{_mandir}/man1/%{spu_prefix}size.1*
%{_mandir}/man1/%{spu_prefix}strings.1*
%{_mandir}/man1/%{spu_prefix}strip.1*

%files -n spu-newlib
%defattr(-,root,root)
%dir %{_prefix}
%dir %{_prefix}/%{spu_target_platform}
%dir %{_prefix}/%{spu_target_platform}/include
%dir %{_prefix}/%{spu_target_platform}/lib
%{_prefix}/%{spu_target_platform}/include/*.h
%{_prefix}/%{spu_target_platform}/include/machine/*.h
%{_prefix}/%{spu_target_platform}/include/sys/*.h
%{_prefix}/%{spu_target_platform}/lib/*.[ao]

%files -n spu-gdb
%defattr(-,root,root)
%dir %{_prefix}
%dir %{_prefix}/bin
%dir %{_mandir}
%dir %{_mandir}/man1
%{_prefix}/bin/%{spu_prefix}gdb*
%{_mandir}/man1/%{spu_prefix}gdb*


%changelog
* Tue Nov 21 2006  Alan Modra  <amodra@au1.ibm.com>  3.3-72
- Fix a segfault on closing archives (nm --print-armap).

* Mon Nov 20 2006  Alan Modra  <amodra@au1.ibm.com>  3.3-71
- ibm28945 looping in map_segments.  Backport lang_size_sections code
  from mainline binutils to set section lmas correctly.

* Sat Nov 18 2006  Alan Modra  <amodra@au1.ibm.com>  3.3-70
- ibm29389 backport 2.17 handling of ADDR() in linker scripts for linux kernel

* Thu Nov 16 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-69
- Fix broken epilog in functions calling alloca (#29346).

* Thu Nov 16 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-68
- GDB: Terminate backtrace at entry function (#29298).

* Tue Nov 14 2006  Alan Modra  <amodra@au1.ibm.com>  3.3-67
- ibm28987 Largefile support.

* Mon Nov 13 2006  Alan Modra  <amodra@au1.ibm.com>  3.3-66
- fix non-zero vma in note section.
- ibm29099 gas/1118 fix clash between --alternate and -al=file

* Wed Nov 8 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-65
- Adapt embedspu script to work with shared SPU/PPU prefix (#29064).

* Tue Nov 7 2006 Sa Liu <saliu@de.ibm.com> 3.3-64
- SPU GCC saves and restores stack pointer in block scope.

* Tue Nov 7 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-63
- Add back BuildRoot to allow rebuilding the SRPM.

* Mon Nov 6 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-62
- Implement TWG RFC 00076-0 (double-precision FP_CONTRACT default).

* Sun Nov 5 2006  Dorit Nuzman  <dorit@il.ibm.com>  3.3-61
- Fix and re-enable empty latch blocks patch

* Fri Nov 3 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-60
- Disable empty latch blocks patch due to wrong-code bugs.

* Thu Nov 3 2006 Sa Liu <saliu@de.ibm.com> 3.3-59
- Call macro C_COMMAND_OVERRIDE_OPTIONS to disable warnings
  about non-standard "main" function on SPU.

* Wed Nov 1 2006  Alan Modra  <amodra@au1.ibm.com>  3.3-58
- ppu binutils merge.

* Tue Oct 31 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-57
- Fix sysrooted startfile search path on SPU.

* Tue Oct 31 2006  Tehila Meyzels  <tehila@il.ibm.com>  3.3-56
- Add empty latch blocks patch.

* Fri Oct 27 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-55
- Finish implementation of GDB SPE enhancements.

* Fri Oct 27 2006  Alan Modra  <amodra@au1.ibm.com>  3.3-54
- ppu binutils merge

* Tue Oct 24 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-53
- Use common PPU/SPU sysroot for the cross-toolchain.
- Change cross-prefix to /opt/cell/toolchain-3.3 (no /spu).

* Mon Oct 23 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-52
- Fix FLT_MIN/FLT_MAX problem (RFC 00067, LTC #27347).

* Mon Oct 23 2006 Tehila Meyzels <tehila@il.ibm.com> 3.3-51
- Implement an emulation of BCT instruction to enable doloop analysis
  and transformations.
- Change doloop_modify to copy the COND_BR_PROB to the newly created 
  jump instruction. This is used to generate correct hints for the BCT loops.
- Modifies the profitability check of the SMS
- Add computation of the scheduling windows to prevent register moves.

* Sun Oct 22 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-50
- Add GDB SPE enhancements, refactor GDB patches.

* Fri Oct 20 2006  Alan Modra  <amodra@au1.ibm.com>  3.3-49
- ppu binutils merge.
- Cosmetic changes to spu function name

* Thu Oct 19 2006  Ben Elliston  <bje@au.ibm.com>  3.3-48
- GCC vector initialiser fixes for some installed headers.

* Fri Oct 13 2006  Ben Elliston  <bje@au.ibm.com>  3.3-47
- Switch to GCC-style vector initialisers in some libgcc routines.
- Update newlib sources, too.

* Thu Oct 12 2006  Ben Elliston  <bje@au.ibm.com>  3.3-46
- Remove support for parenthesised vector initialisers.

* Tue Oct 10 2006  Alan Modra  <amodra@au1.ibm.com>  3.3-45
- Ignore zero size sections when checking spu local store limits.

* Mon Oct 9  2006  Dorit Nuzman  <dorit@il.ibm.com>  3.3-44
- Fix vectorizer testcase failures.

* Mon Oct 9 2006  Ben Elliston  <bje@au.ibm.com>  3.3-43
- Make gcc.c-torture/execute/builtins/strlen.c robust against strcpy
  implementations that call strlen.

* Fri Oct 6 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-42
- Fix missing generated file in binutils-config.diff.

* Fri Oct 6 2006  Alan Modra  <amodra@au1.ibm.com>  3.3-41
- Fix .note.spu_name

* Fri Oct 6 2006  Alan Modra  <amodra@au1.ibm.com>  3.3-40
- ppu binutils merge.

* Fri Sep 29 2006  Ben Elliston  <bje@au.ibm.com>  3.3-39
- Bring over Altivec keyword fix from the PPU compiler.

* Thu Sep 28 2006  Markus Deuling  <deuling@de.ibm.com>  3.3-38
- Add gdb long double fix

* Thu Sep 28 2006  Alan Modra  <amodra@au1.ibm.com>  3.3-37
- Prevent overlay stubs on user supplied overlay manager functions.

* Thu Sep 28 2006  Alan Modra  <amodra@au1.ibm.com>  3.3-36
- Add ld dependency on gas, for combined tree make -j

* Wed Sep 27 2006  Ben Elliston  <bje@au.ibm.com>  3.3-35
- Import second batch of testsuite fixes.

* Wed Sep 27 2006  Alan Modra  <amodra@au1.ibm.com>  3.3-34
- Fix --enable-targets=all build when 32-bit host and target.
- For overlays, warn on calls to non-function syms.
- Build spu_ovl.o even when not maintainer mode.

* Tue Sep 26 2006  Ben Elliston  <bje@au.ibm.com>  3.3-33
- Implement TWG RFC 00065-0 (volatile scratch registers).

* Tue Sep 26 2006  Dorit Nuzman  <dorit@il.ibm.com>  3.3-32
- Add flag to limit vectorization to loops with large enough loop bound.

* Tue Sep 26 2006  Ben Elliston  <bje@au.ibm.com>  3.3-31
- XFAIL compat tests that produce relocation overflows.

* Tue Sep 26 2006  Alan Modra  <amodra@au1.ibm.com>  3.3-30
- Add ld build dependency on gas
- Correct typo in md_apply_fix3 that caused trashed opcode field on lqd/stqd.

* Mon Sep 25 2006  Ben Elliston  <bje@au.ibm.com>  3.3-29
- Add Alan's fixes9 patch:
  * Replace SPU_GLOB_DAT with SPU_ADDR32.
  * Reenable gc-sections.
  * Stop --extra-overlay-stubs generating unneccesary intra-segment stubs.

* Sun Sep 24 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-28
- Update spu-gdb to GDB 6.5 base version.

* Fri Sep 22 2006  Ben Elliston  <bje@au.ibm.com>  3.3-27
- Pass -E to patch(1) when applying patch #27.

* Fri Sep 22 2006  Ben Elliston  <bje@au.ibm.com>  3.3-26
- Import the first set of testsuite fixes.

* Wed Sep 20 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-25
- Add Alan's drop9 binutils patch:
  * Add ADDR32 and REL32 relocs
  * Fix makefile readelf dependency
  * Accept SPU_RdEventMask, not SPU_RdEventStatMask
  * Fix segfault on binary output
  * Overlay manager backchain fixes.  Two bugs.
  * Formatting in spu-dis.c

* Wed Sep 20 2006  Ben Elliston  <bje@au.ibm.com>  3.3-24
- Do not link with -lc_p when the compiler driver is passed -pg.

* Tue Sep 19 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-23
- Add Alan's drop8 binutils patch:
  * lots of formatting and general code cleanup
  * fix handling of BFD_RELOC_{8,16,32,64} so that .byte, .short, long,
    .quad work with expressions containing forward references.
  * say we don't need broken word handling
  * update input-file.c to mainline error messages.

* Tue Sep 19 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-22
- Implement TWG RFC 00053-0 (change mfc_list_element.size bitfield size).
- Implement TWG RFC 00062-0 (change "read event mask" channel mnemonic).
- Remove toolchain-mfcio-stdint.diff hack.

* Tue Sep 19 2006 Sa Liu <saliu@de.ibm.com> 3.3-21
- Switch off TImode support in spu gcc backend.
  Replace word_mode by fast_mode in testsuites. 

* Mon Sep 18 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-20
- Change cross-prefix to /opt/cell (from /opt/sce).

* Sun Sep 17 2006  Dorit Nuzman    <dorit@il.ibm.com>     3.3-19
- Backport vectorization of reduction-patterns from mainline and
  vectorization of multiple data-types and type-conversions from autovect-branch.
- Model vector widening multiplication (high/low and even/odd).  

* Fri Sep 15 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-18
- Backport GDB fix allowing section start address of zero.

* Fri Sep 15 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-17
- Update intrinsic mapping header files to Dan's latest revision.

* Fri Sep 15 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-16
- Add Alan's drop6 and drop7 binutils patches:
  * Rewrite the overlay manager support to automate build from source.
  * Don't support spu by default for powerpc.  (use --enable-targets=spu-elf
    if you want spu support.)
  * Fix some testsuite failures.
  * Allow user supplied __ovly_load again, and as a weak sym.
  * Error out on missing gas input file.
  * Build fix.

* Tue Sep 12 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-15
- Add backport of GCC bugzilla #28862 (LTC #25516).

* Tue Sep 12 2006 Sa Liu <saliu@de.ibm.com> 3.3-14
- Add cleanup patch to separate C/C++ specific code from that
  for common frontend.

* Tue Sep 12 2006  Ben Elliston  <bje@au.ibm.com>  3.3-13
- Add testsuite jumbo patch to remove erroneous XFAILs.

* Tue Sep 12 2006  Ben Elliston  <bje@au.ibm.com>  3.3-12
- Use configure-time tests to determine if libstdc++ can be built with
  -ffunction-sections -fdata-sections.

* Tue Sep 5 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-11
- Add Alan's drop4 and drop5 binutils patches:
  * .interrupt section support and .text start at zero
  * stub symbol name changes
  * simple VMA range checks

* Tue Sep 5 2006 Sa Liu <saliu@de.ibm.com> 3.3-10
- Add patch for crt0 formalization.

* Mon Sep 5 2006  Dorit Nuzman  <dorit@il.ibm.com>	  3.3-9
- Support auto-vectorization of misaligned loads.

* Fri Sep 1 2006  Ben Elliston  <bje@au.ibm.com>  3.3-8
- Patch in regenerated libstdc++ Makefile.in files.

* Wed Aug 30 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-7
- More fixes to binutils overlay support.

* Mon Aug 28 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-6
- Fixes to binutils/GDB overlay support.

* Sat Aug 26 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-5
- Add GDB overlay support.

* Fri Aug 25 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-4
- Fix incorrect DWARF debug info (#26634).

* Thu Aug 24 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-3
- Fix incorrect _ovly_table-16 reloc in __ovly_copy.

* Mon Aug 21 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-2
- Add Alan's spu binutils rework, including overlay support.
- Fix unwind headers word_mode/fast_mode mismatch bug.
- Re-enable libstdc++ build, do not build/package gprof.

* Fri Aug 18 2006  Markus Deuling  <deuling@de.ibm.com>  3.3-1
- Individual BuildRoot for each user from Makefile to support multiple users on a host 

* Wed Aug 16 2006  Ben Elliston  <bje@au.ibm.com>  3.3-1
- Bump package version number.

* Wed Aug 16 2006  Ben Elliston  <bje@au.ibm.com>  3.2-12
- Update gcc_version and %description.
  Do not build or package libstdc++.
  Package gprof and its man page.

* Mon Aug 14 2006  Ben Elliston  <bje@au.ibm.com>  3.2-11
- Remove unnecessary patches: toolchain-libiberty-merge.diff,
  toolchain-convertible-revert.diff.

* Tue Jul 25 2006 Sa Liu <saliu@de.ibm.com> 3.2-10
- Add option -mfixed-range to SPU GCC.

* Thu Jul 18 2006 Sa Liu <saliu@de.ibm.com> 3.2-9
- Fix a bug of user specified alignment in SPU GCC.
  Fix inaccurate floating point division.

* Thu Jul 13 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.2-8
- Update to newlib version 1.14.0.

* Mon Jul 10 2006  Patrick Mansfield <patmans@us.ibm.com> 3.2-7
- Add support for embedspu.sh handling of the special variable _EAR_ for
  overlay support.

* Sun Jul 2 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.2-6
- Fixes for 64-bit PPE application support.

* Mon Jun 19 2006  Markus Deuling  <deuling@de.ibm.com>  3.2-6
- Add gdb.asm testcases to spu-gdb.

* Fri Jun 09 2006  Sa Liu  <saliu@de.ibm.com>  3.2-5
- Fix bugs in newlib setjmp and longjmp.

* Wed May 24 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.2-4
- Add support for cross-toolchain build.

* Wed May 17 2006  Markus Deuling  <deuling@de.ibm.com>  3.2-3
- Fix broken CELL LOCAL changes.

* Mon May 8 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.2-2
- Bump version.

* Thu Apr 25 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.2-1bb1
- Update to SCEA toolchain release 3.2.

* Tue Mar 28 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.0-20060124bb1
- Update to SCEA 20060124 GCC 4.0.2 toolchain snapshot.
- Add spu-gdbserver support.
- Remove gdb support for pre-SDK 1.0 experimental kernels.

* Fri Feb 10 2006  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-2be6
- Fix incorrect REG_EQUAL note hoists by loop.c.

* Wed Nov 23 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-2be5
- Fix HBR relocation overflow due to ignored jump table sizes.

* Wed Nov 23 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-2be4
- When attaching to a running SPE thread, extract ELF image from memory.

* Thu Nov 10 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-2be3
- Enable attaching spu-gdb to running SPE threads.

* Thu Nov 3 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-2be2
- Fix build problems on FC 4.

* Wed Oct 26 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-2be1
- Move to CVS head and adapt make logic.

* Fri Oct 21 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-be11_3_5
- Add CESOF support to spu-binutils and embedspu script.
- Build with -DBPA for binutils.

* Sun Oct 9 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-be11_3_4
- Handle inferior startup in spu-gdb without libspe SPU_PTRACE_ME support.

* Thu Oct 6 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-be11_3_3
- Fix C++ library header file install location.
- Fix embedspu script to generate spe_program_header_t headers.

* Tue Oct 4 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-be11_3_2
- Update to SCEA toolchain version 2.3+.

* Fri Sep 9 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-1be8
- Cope with circular dependency between libc.a and libgloss.a.
- Deactivate printf-dependent GDB test case.

* Fri Sep 9 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-1be7
- Replace JSRE newlib by IBM implementation.  Add -lgloss to
  default compiler LIB_SPEC.

* Fri Sep 2 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-1be6
- Update GDB to understand 'read', 'ioctl', and 'spu_run' calls.

* Fri Aug 26 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-1be5
- Update GDB to understand 'read' instead of 'ioctl' on run file.

* Thu Aug 25 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-1be4
- Do not build libgloss.  Remove -lsim from default LINK_SPEC.
- Fix ODT g9739 (ICE on large stack frames).

* Fri Aug 12 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-1be3
- Use embedspu script from SCEA tarball.
- Rename ODT g6218 fix.

* Fri Aug 12 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-1be2
- Add toolchain-trampoline-sync.diff.

* Tue Aug 9 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-1be1
- Update to SCEA toolchain version 2.3.

* Thu Jul 15 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.2-1be4
- Add spu-gdb package.

* Thu Jul 15 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.2-1be3
- Fix ODT g6218.

* Thu Jun 9 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.2-1be2
- Add embedspu script to spu-binutils RPM.

* Fri May 27 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.2-1be1
- Update to SCEA toolchain version 2.2.

* Mon Apr 18 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.1-1be1
- Initial version of spu-toolchain RPM based on SCEA toolchain
  version 2.1.

